$error = ForceRequiredAddOn("Weapon_Gun");
if($error == $Error::AddOn_Disabled) GunItem.uiName = "";

datablock AudioProfile(KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/fire1.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(KnockbackShotgunBlast2Sound : KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/fire2.wav";
};
datablock AudioProfile(KnockbackShotgunBlast3Sound : KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/fire3.wav";
};
datablock AudioProfile(KnockbackShotgunBreakSound : KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/break.wav";
};
datablock AudioProfile(KnockbackShotgunUnBreakSound : KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/unbreak.wav";
};
datablock AudioProfile(KnockbackShotgunLoadSound : KnockbackShotgunBlast1Sound)
{
   filename    = "./sound/load.wav";
};
datablock DebrisData(KnockbackShotgunShellDebris)
{
	shapeFile = "./model/shotgunshell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ParticleData(KnockbackShotgunTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 120;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;

	textureName		= "base/data/particles/dot";

	colors[0]	= "1 1 0 1";
	colors[1]	= "1 1 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(KnockbackShotgunTrailEmitter)
{
	ejectionPeriodMS = 2;
	periodVarianceMS = 0;

	ejectionVelocity = 0;
	velocityVariance = 0;

	ejectionOffset = 0;

	thetaMin         = 0.0;
	thetaMax         = 90.0;  

	particles = KnockbackShotgunTrailParticle;

	useEmitterColors = true;
};
AddDamageType("BoomStick",   '<bitmap:Add-ons/Weapon_BoomStick/model/ci_shotgun> %1',    '%2 <bitmap:Add-ons/Weapon_BoomStick/model/ci_shotgun> %1',0.2,1);
datablock ProjectileData(KnockbackShotgunProjectile : gunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 4;
   verticalImpulse 	   = 200;
   impactImpulse 	   = 300;
   directDamageType    = $DamageType::HuntingShotgun;
   radiusDamageType    = $DamageType::HuntingShotgun;
   particleEmitter     = KnockbackShotgunTrailEmitter;
   explosion = GunExplosion;
};
datablock ItemData(KnockbackShotgunItem)
{
	category = "Weapon";
	className = "Weapon";

	 // Basic Item Properties
	shapeFile = "./model/shotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Boomstick";
	iconName = "./model/icon_shotgun";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = KnockbackShotgunImage;
	canDrop = true;
};
datablock ShapeBaseImageData(KnockbackShotgunImage)
{
	shapeFile = "./model/shotgun.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );

	correctMuzzleVector = true;

	className = "WeaponImage";

	item = KnockbackShotgunItem;
	ammo = " ";
	projectile = KnockbackShotgunProjectile;
	projectileType = Projectile;

	casing = KnockbackShotgunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = KnockbackShotgunItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.67;
	stateSequence[0]				= "root";
	stateTransitionOnTimeout[0]     = "Idle";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Idle";
	stateTransitionOnTriggerDown[1] = "Fire";
	
	stateName[2]                   	= "Fire";
	stateTransitionOnTimeout[2]    	= "Smoke";
	stateTimeoutValue[2]           	= 0.14;
	stateFire[2]                   	= true;
	stateAllowImageChange[2]       	= false;
	stateSequence[2]               	= "root";
	stateScript[2]                 	= "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	
	stateName[3] 					= "Smoke";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.2;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.2;
	stateTransitionOnTimeout[3]     = "Break";
	
	stateName[4]					= "Break";
	stateSequence[4]				= "break";
	stateScript[4]					= "onBreak";
	stateAllowImageChange[4]        = false;
	stateTimeoutValue[4]            = 0.15;
	stateTransitionOnTimeout[4]     = "UnloadA";
	
	stateName[5]					= "UnloadA";
	stateSequence[5]				= "unload";
	stateScript[5]					= "onUnload";
	stateAllowImageChange[5]        = false;
	stateEjectShell[5]				= true;
	stateTimeoutValue[5]            = 0.01;
	stateTransitionOnTimeout[5]     = "UnloadB";
	
	stateName[6]					= "UnloadB";
	stateAllowImageChange[6]        = false;
	stateEjectShell[6]				= true;
	stateTimeoutValue[6]            = 0.01;
	stateTransitionOnTimeout[6]     = "LoadA";
	
	stateName[7]					= "LoadA";
	stateSequence[7]				= "leftReload";
	stateScript[7]					= "onLoadA";
	stateAllowImageChange[7]        = false;
	stateTimeoutValue[7]            = 0.1;
	stateTransitionOnTimeout[7]     = "LoadB";
	
	stateName[8]					= "LoadB";
	stateSequence[8]				= "rightReload";
	stateScript[8]					= "onLoadB";
	stateAllowImageChange[8]        = false;
	stateTimeoutValue[8]            = 0.1;
	stateTransitionOnTimeout[8]     = "Unbreak";
	
	stateName[9]					= "Unbreak";
	stateSequence[9]				= "unbreak";
	stateScript[9]					= "onUnbreak";
	stateAllowImageChange[9]        = false;
	stateTimeoutValue[9]            = 0.1;
	stateTransitionOnTimeout[9]     = "Idle";
	
};
function KnockbackShotgunImage::onBreak(%this,%obj,%slot)
{
	%obj.schedule(30,playThread,2,plant);
	serverPlay3D(KnockbackShotgunBreakSound,%obj.getPosition());
}
function KnockbackShotgunImage::onLoadA(%this,%obj,%slot)
{
	serverPlay3D(KnockbackShotgunLoadSound,%obj.getPosition());
}
function KnockbackShotgunImage::onLoadB(%this,%obj,%slot)
{
	serverPlay3D(KnockbackShotgunLoadSound,%obj.getPosition());
}
function KnockbackShotgunImage::onUnbreak(%this,%obj,%slot)
{
	%obj.schedule(100,playThread,2,plant);
	serverPlay3D(KnockbackShotgunUnBreakSound,%obj.getPosition());
}
function KnockbackShotgunImage::onFire(%this,%obj,%slot)
{
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);

	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);

	%eXY = mSqrt(%eX*%eX+%eY*%eY);

	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	
	%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"-7")));
	%obj.playThread(2, plant);
	%n = getRandom(1,3);
	serverPlay3D("KnockbackShotgunBlast" @ %n @ "Sound",%obj.getPosition());
	
	%projectile = %this.projectile;
	%spread = 0.013;
	%shellcount = 12;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		missionCleanup.add(%p);
	}
}